#include <QtGui/QApplication>
#include <QDBusConnection>
#include <QDBusInterface>
#include <QDBusReply>
#include <iostream>
#include <stdint.h>

class ScreenSaverDBus
{
  public:
    ScreenSaverDBus() {};
    ~ScreenSaverDBus() {};
    void Spork(void)
    {
        QDBusConnection bus = QDBusConnection::sessionBus();
        QDBusInterface *interface = new QDBusInterface("org.freedesktop.ScreenSaver",
                                                   "/ScreenSaver",
                                                   "org.freedesktop.ScreenSaver"); 
        QList<QVariant> args;
        args.append("MythTV");
        args.append("Watching TV");
        QDBusReply<uint32_t> reply = interface->callWithArgumentList(QDBus::Block, "Inhibit", args);
        if (reply.isValid())
        {
            std::cout << "Cookie is " << reply.value() << std::endl;
        }
        else
        {
            std::cout << "Call failed" << std::endl;
        }
    }
};

int main(int argv, char **args)
{
	QApplication app(argv, args);
    ScreenSaverDBus ss;
    ss.Spork();
	return app.exec();
}
